#include <stm32f4xx.h>
#include "regwrites.h"

/*
helper functions written by Peter Lawrence

no warranty is provided with this code
*/

void setbitpair(volatile uint32_t *reg, uint32_t position, uint32_t state)
{
  uint32_t result = *reg;

  if ( (position < 16) && (state < 4) )
  {
    result &= ~(3 << (position * 2));
    result |= state << (position * 2);
    *reg = result;
  }
}

void setbit32(volatile uint32_t *reg, uint32_t position, uint32_t state)
{
  uint32_t result = *reg;

  if (position < 32)
  {
    if (state)
      result |= 1 << position;
    else
      result &= ~(1 << position);
    *reg = result;
  }
}

void setnibble(volatile uint32_t reg[2], uint32_t position, uint32_t state)
{
  uint32_t result;
  volatile uint32_t *thereg;
   
  if (position > 8)
  {
    thereg = &reg[1];
    position -= 8;
  }
  else
  {
    thereg = &reg[0];
  }

  result = *thereg;

  if ( (position < 8) && (state < 16) )
  {
    result &= ~(0xF << (position * 4));
    result |= state << (position * 4);
    *thereg = result;
  }
}

void setbit16(volatile uint16_t *reg, uint32_t position, uint16_t state)
{
  uint16_t result = *reg;

  if (position < 16)
  {
    if (state)
      result |= 1 << position;
    else
      result &= ~(1 << position);
    *reg = result;
  }
}
