
// These are defined and created by the linker, locating them in memory
extern unsigned char _etext;
extern unsigned char _data;
extern unsigned char _edata;
extern unsigned char _bss;
extern unsigned char _ebss;

// Prototype the required startup functions
extern int main(void);
extern void SystemInit(void);

// The entry point of the application, prepare segments,
// initialize the cpu and execute main()
void boot_entry(void)
{
  register unsigned char *src, *dst;

  // Get physical data address and copy it to sram
  src = &_etext;
  dst = &_data;
  while(dst < &_edata) {
    *dst++ = *src++;
  }

  // Clear the bss segment
  dst = &_bss;
  while(dst < &_ebss) {
    *dst++ = 0;
  }
  // initialize the clocks
  SystemInit();

  // Execute the code at the program entry point
  main();

  // Do nothing when returned from main, just keep looping
  while(1);
}
